#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "err.h"

int main ()
{
  pid_t pid;
  
  printf("My process id = %d\n", getpid());
  
  switch (pid = fork()) {
    case -1:
      syserr("Error in fork\n");
      
    case 0:
      printf("Child process: My process id = %d\n", getpid());
      printf("Child process: Value returned by fork() = %d\n", pid);

      execlp("ps", "ps", 0);
      syserr("Error in execlp\n");
            
    default:
      printf("Father process. My process id = %d\n", getpid());
      printf("Father process. Value returned by fork() = %d\n", pid);
       
      if (wait(0) == -1) 
	syserr("Error in wait\n");
      exit(0);
  } /*switch*/
}
