#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "err.h"

#define NR_PROC 5

int main ()
{
  pid_t pid;
  int i;

  printf("My process id = %d\n",getpid());

  for (i = 1; i <= NR_PROC; i++)
    switch ( pid = fork() ) {
      case -1:
        syserr("Error in fork\n");
	 
      case 0:
	printf("Child process: My process id = %d\n", getpid());
	printf("Child process: Value returned by fork() = %d\n", pid);
	return 0;
       
      default:
	printf("Father process. My process id = %d\n", getpid());
	printf("Father process. Value returned by fork() = %d\n", pid);
       
    } /* switch */ 
   
  for (i = 1; i <= NR_PROC; i++)
    if (wait(0) == -1) 
      syserr("Error in wait\n");
  return 0;
}
